// data structures
const LinkedList = require('./data-structures/linked-lists/linked-list');
const ListNode = require('./data-structures/linked-lists/node');
const Queue = require('./data-structures/queues/queue');
const Stack = require('./data-structures/stacks/stack');
const Graph = require('./data-structures/graphs/graph');
const HashMap = require('./data-structures/maps/hash-maps/hash-map');
const TreeMap = require('./data-structures/maps/tree-maps/tree-map');
const HashSet = require('./data-structures/sets/hash-set');
const TreeSet = require('./data-structures/sets/tree-set');
const ArraySet = require('./data-structures/sets/array-set');
const MapSet = require('./data-structures/sets/map-set');
const BinarySearchTree = require('./data-structures/trees/binary-search-tree');
const BinaryTreeNode = require('./data-structures/trees/binary-tree-node');
const AvlTree = require('./data-structures/trees/avl-tree');
const RedBlackTree = require('./data-structures/trees/red-black-tree');
const LRUCache = require('./data-structures/custom/lru-cache');
const Trie = require('./data-structures/trees/trie');
const Heap = require('./data-structures/heaps/heap');
const MinHeap = require('./data-structures/heaps/min-heap');
const MaxHeap = require('./data-structures/heaps/max-heap');
const PriorityQueue = require('./data-structures/heaps/priority-queue');

// algorithms
const bubbleSort = require('./algorithms/sorting/bubble-sort');
const insertionSort = require('./algorithms/sorting/insertion-sort');
const selectionSort = require('./algorithms/sorting/selection-sort');
const quickSort = require('./algorithms/sorting/quick-sort');
const mergeSort = require('./algorithms/sorting/merge-sort');

module.exports = {
  LinkedList,
  ListNode,
  Queue,
  Stack,
  Graph,
  HashMap,
  TreeMap,
  HashSet,
  TreeSet,
  ArraySet,
  MapSet,
  BinarySearchTree,
  BinaryTreeNode,
  AvlTree,
  RedBlackTree,
  LRUCache,
  Trie,
  Heap,
  MinHeap,
  MaxHeap,
  PriorityQueue,
  bubbleSort,
  insertionSort,
  selectionSort,
  quickSort,
  mergeSort,
};
